if (window.jQuery) {
  (function ($) {
    $(document).ready(function () {
      var _flowValidatorURL = sessionStorage.getItem("_flowValidatorURLSS") ? decodeURIComponent(sessionStorage.getItem("_flowValidatorURLSS")) : '';
      /*Email field related script*/
      /*Set custom submit*/
      $('#InsertButton').hide();
      $('.actions').append('<input type="button" class="submit-btn btn btn-primary form-action-container-left" id="customSubmitBtn" value="Submit">');
      $('#customSubmitBtn').on('click', function () {
        setBrokerDetails();
        validateEmailAsync().then((data) => {
          emailValid = data;
          $("#InsertButton").trigger('click');
          if (typeof entityFormClientValidate === 'function') {
            if (entityFormClientValidate()) {
              if (typeof Page_ClientValidate === 'function') {
                if (Page_ClientValidate('')) {
                  clearIsDirty();
                  disableButtons();
                  this.value = 'Processing...';
                }
              }
              else {
                clearIsDirty();
                disableButtons();
                this.value = 'Processing...';
              }
            }
            else {
              return false;
            }
          }
          else {
            if (typeof Page_ClientValidate === 'function') {
              if (Page_ClientValidate('')) {
                clearIsDirty();
                disableButtons();
                this.value = 'Processing...';
              }
            }
            else {
              clearIsDirty();
              disableButtons();
              this.value = 'Processing...';
            }
          };
        });
      });
      /*Set custom submit*/
      if (typeof Page_Validators == "undefined") return;

      // Create a new validator
      var newValidatorEmail = document.createElement("span");
      newValidatorEmail.style.display = "none";
      newValidatorEmail.id = "leadgen_emailaddressValidator";
      newValidatorEmail.controltovalidate = "leadgen_emailaddress";
      newValidatorEmail.errormessage =
        "<a href='#leadgen_emailaddress_label' referencecontrolid='leadgen_emailaddress' onclick='javascript:scrollToAndFocus(\"leadgen_emailaddress_label\",\"leadgen_emailaddress\");return false;'>Enter a valid email address.</a>";
      newValidatorEmail.validationGroup = ""; // Set this if you have set ValidationGroup on the form
      newValidatorEmail.initialvalue = "";

      var emailValid = false;

      // Custom validation function
      newValidatorEmail.evaluationfunction = function () {
        $('#leadgen_state').val($('#stateCode').text());
        $('#leadgen_costcenter').val($('#branchCode').text());
        $("#leadgen_whatisyourcostcentre").val($("#branchCode").text());
        return emailValid;
      };

      $(".actions").hover(function () {
        validateEmailAsync().then((data) => {
          emailValid = data;
        });
      });
      $("#leadgen_emailaddress").on("focusout", function () {
        validateEmailAsync().then((data) => {
          emailValid = data;
        });
      });
      // Add the new validator to the page validators array
      Page_Validators.push(newValidatorEmail);

      // Asynchronous email validation function
      async function validateEmailAsync() {
        const targetEmail = $("#leadgen_emailaddress").val();
        const validEmailRegex =
          /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/;

        if (validEmailRegex.test(targetEmail)) {
          const apiURL = _flowValidatorURL ? _flowValidatorURL : 'https://prod-15.australiaeast.logic.azure.com:443/workflows/ff1261ff34484036b9f6d5d29f602691/triggers/manual/paths/invoke?api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&sv=1.0&sig=uck1ZnjyjcdK5vOwQwHsziwxKkS3YDdImtzmZoXTJd4';
          const dataToValidator = { targetEmail };

          try {
            const response = await fetch(apiURL, {
              method: "POST",
              headers: {
                "Content-Type": "application/json",
              },
              body: JSON.stringify(dataToValidator),
            });

            if (!response.ok) {
              throw new Error(`HTTP error! Status: ${response.status}`);
            }

            const data = await response.json();

            // Check if the email is valid
            const isValid =
              data.status === "catch-all" || data.status === "valid";

            // Update the validation status
            newValidatorEmail.isvalid = isValid;

            return isValid;
          } catch (error) {
            console.error(`Error fetching data: ${error}`);
            return false;
          }
        } else {
          return false;
        }
      }
      /*Email field related script*/
      /*Preferred contact field related script*/
      //hide preferred time to contact field on load
      let preferredTimeTdElement = $("#leadgen_preferredtimetocontact").closest(
        "td"
      );
      preferredTimeTdElement.hide();
      //hide preferred time to contact field on load
      /*Enabling preferred time to contact based on Preferred contact method field*/
      $("#leadgen_preferredcontactmethod").change(function () {
        $("#leadgen_preferredtimetocontact").val("");
        let selectedSource = $(
          "#leadgen_preferredcontactmethod option:selected"
        ).text();
        if (selectedSource === "Phone") {
          preferredTimeTdElement.show();
        } else {
          preferredTimeTdElement.hide();
        }
      });
      /*Enabling preferred time to contact based on Preferred contact method field*/
      /*Preferred contact field related script*/

      /*Phone Number field related script*/
      $("#leadgen_phonenumber").attr("autocomplete", "off");
      $("#leadgen_phonenumber").on("keypress", function (event) {
        // Allow only digits (0-9)
        if (
          event.which < 48 ||
          event.which > 57 ||
          event.target.value.length > 9
        ) {
          event.preventDefault();
        }
      });
      var newValidatorPhone = document.createElement("span");
      newValidatorPhone.style.display = "none";
      newValidatorPhone.id = "leadgen_phonenumberValidator";
      newValidatorPhone.controltovalidate = "leadgen_phonenumber";
      newValidatorPhone.errormessage =
        "<a href='#leadgen_phonenumber_label' referencecontrolid='leadgen_phonenumber' onclick='javascript:scrollToAndFocus(\"leadgen_phonenumber_label\",\"leadgen_phonenumber\");return false;'>Phone number should be 10 digit. Please enter a valid Phone number.</a>";
      newValidatorPhone.validationGroup = ""; // Set this if you have set ValidationGroup on the form
      newValidatorPhone.initialvalue = "";
      // Custom validation function
      newValidatorPhone.evaluationfunction = function () {
        let phoneNumVal = $("#leadgen_phonenumber").val();
        if (phoneNumVal.length < 10) {
          return false;
        } else {
          return true;
        }
      };
      Page_Validators.push(newValidatorPhone);
      /*Phone Number field related script*/
    });
    function setBrokerDetails() {
      console.log("Inside setbrokerdetails");
      var urlPath = localStorage.getItem("URL-PATH");
      console.log("URL Path: " + urlPath);
      var brokerDetl = $("#leadgen_brokersname");
      if (urlPath && brokerDetl) {
        brokerDetl.val(urlPath);
        console.log("Broker Detl: " + brokerDetl.val());
      }
    }
  })(window.jQuery);
}
